// vim:syntax=javascript

class Interstitial extends MovieClip {
    var fadeInDoneCallback:Function;
    var delayDoneCallback:Function;
    var fadeOutDoneCallback:Function;
    var fade_speed:Number;
    var delay_frames:Number;
    var message:String;
    var message_txt:TextField;

    function onLoad() {
        var static_this:Interstitial = this;

        _alpha = 0;

        if (!hasOwnProperty("fade_speed")) {
            fade_speed = 10;
        }

        if (!hasOwnProperty("delay_frames")) {
            delay_frames = 24;
        }

        if (!hasOwnProperty("message")) {
            message = "";
        }

        if (!hasOwnProperty("fadeInDoneCallback")) {
            fadeInDoneCallback = function() {};
        }
        if (!hasOwnProperty("delayDoneCallback")) {
            delayDoneCallback = function() {};
        }
        if (!hasOwnProperty("fadeOutDoneCallback")) {
            fadeOutDoneCallback = function() {};
        }

        // render message
        var style_fmt:TextFormat = new TextFormat();
        with (style_fmt) {
            font = "Vera";
            size = 20;
            color = 0xFFFFFF;
            align = "center";
        }

        createTextField("message_txt", getNextHighestDepth(), 
                        0, 0, Stage.width, Stage.height);
        with (message_txt) {
            multiline = true;
            embedFonts = true;
            selectable = false;
            border = true;
            borderColor = 0x000000;
            background = true;
            backgroundColor = 0x000000;
            setNewTextFormat(style_fmt);
            text = message;
        }

        // set up fade stuff
        var fade_in_fcn:Function;
        var delay_fcn:Function;
        var fade_out_fcn:Function;

        fade_in_fcn = function() {
            with (static_this) {
                _alpha += fade_speed;
                if (_alpha >= 100) {
                    _alpha = 100;
                    delete onEnterFrame;

                    fadeInDoneCallback();

                    onEnterFrame = delay_fcn;
                }
            }
        };

        delay_fcn = function() {
            with (static_this) {
                delay_frames --;
                if (delay_frames < 0) {
                    delete onEnterFrame;

                    delayDoneCallback();
                    
                    onEnterFrame = fade_out_fcn;
                }
            }
        };

        fade_out_fcn = function() {
            with (static_this) {
                _alpha -= fade_speed;
                if (_alpha <= 0) {
                    _alpha = 0;
                    delete onEnterFrame;

                    fadeOutDoneCallback();

                    removeMovieClip();
                }
            }
        }

        onEnterFrame = fade_in_fcn;
    }
}
