// vim:syntax=javascript

// a particle keeps track of its own velocity, but the actual physics logic
// occurs elsewhere

class Particle {
    private static var _PARTICLE_SIZE : Number = 20;
    private static var _PARTICLE_SIZE_SQ : Number = 20*20;
    private var _x : Number;
    private var _y : Number;
    private var _ix : Number;
    private var _iy : Number;
    private var _vx : Number;
    private var _vy : Number;
    private var _ivx : Number;
    private var _ivy : Number;
    private var _charge : Number;
    private var _mc : MovieClip;

    static function get PARTICLE_SIZE () : Number {return _PARTICLE_SIZE;}
    function get x () : Number {return _x;}
    function get y () : Number {return _y;}
    function get vx () : Number {return _vx;}
    function get vy () : Number {return _vy;}
    function get charge () : Number {return _charge;}

    function Particle(mc : MovieClip, charge : Number, x : Number, y : Number, vx : Number, vy : Number) {
        _mc = mc;
        _charge = charge;
        _ix = x;
        _iy = y;
        _ivx = vx;
        _ivy = vy;
        _mc._width = PARTICLE_SIZE;
        _mc._height = PARTICLE_SIZE;

        reset();
    }

    function reset() {
        _x = _ix;
        _y = _iy;

        _vx = _ivx;
        _vy = _ivy;

        draw();
    }

    function draw() {
        _mc._x = _x - PARTICLE_SIZE/2;
        _mc._y = _y - PARTICLE_SIZE/2;
    }

    function update(x : Number, y : Number, vx : Number, vy : Number) {
        _x = x;
        _y = y;
        _vx = vx;
        _vy = vy;

        draw();
    }

    function remove() {
        _mc.removeMovieClip();
        delete _mc;
    }

    function toString() : String {
        return "Particle for "+_mc+", charge "+_charge+" at ("+_x+","+_y+") vel ("+_vx+","+_vy+") [init ("+_ix+","+_iy+") ("+_ivx+","+_ivy+")]";
    }

    function hitTest(po : Object, radius : Number) : Boolean {
        var dx = po.x - _x;
        var dy = po.y - _y;
        if (dx*dx+dy*dy < radius*radius) {
            //trace("vx="+_vx+" "+(dx*dx+dy*dy)+" < "+_PARTICLE_SIZE_SQ);
            return true;
        }
        return false;
    }
}
