// vim:syntax=javascript

// Potential is the name of the game
// It is most certainly not "Use The Force", appropriate as that name might be.

class Potential extends MovieClip {
    var next_level : Number;
    var name_count : Number;
    var lev : Object;
    var levels : Array;
    var statusbar_mc : MovieClip;

    static var MESSAGE_DEPTH : Number = 3;
    static var STATUSBAR_DEPTH : Number = 2;
    static var SIMULATION_DEPTH : Number = 1;

    function onLoad() {
        var static_this = this;
        var rep_comp : Function
        var rep_status : Function;
        var rep_tip : Function;

        next_level = 0;
        name_count = 0;

        levels = [
            Level1,
            Level2,
            Level3,
            Level4,
            Level5,
            Level6];

        attachMovie("statusbar", "statusbar_mc", STATUSBAR_DEPTH);
        statusbar_mc._y = 300;

        rep_comp = function () {
            trace("starting lev"+(static_this.next_level+1));
            static_this.lev = new static_this.levels[static_this.next_level](
            {mc : static_this, name_count : static_this.name_count,
             screen_width : 400, screen_height : 300,
             reportTip : rep_tip,
             reportStatus : rep_status, reportCompletion : rep_comp});

            static_this.statusbar_mc.setLevel(static_this.next_level+1);

            static_this.name_count ++;

            static_this.next_level ++;
            if (static_this.next_level >= static_this.levels.length) {
                static_this.next_level = 0;
            }
        };

        rep_status = function (sim_running : Boolean, particles : /*Particle*/ Array, fields : /*Field*/ Array, max_fields : Number) {
            static_this.statusbar_mc.setRunning(sim_running);
            static_this.statusbar_mc.setFields(fields.length, max_fields);
            if (sim_running) {
                var vx = particles[0].vx;
                var vy = particles[0].vy;
                var vmag = Math.sqrt(vx*vx+vy*vy);
                static_this.statusbar_mc.setVelocity(vmag);
            } else {
                static_this.statusbar_mc.setVelocity(0);
            }
        };

        rep_tip = function (tip : String) {
            static_this.statusbar_mc.setMessage(tip);
        };
        
        statusbar_mc.setVelocity(0);
        statusbar_mc.setLevel(1);
        statusbar_mc.setFields(0,0);
        statusbar_mc.setRunning(false);
        statusbar_mc.setMessage("Welcome to Potential!");
        rep_comp();
    }
}
